

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

extern int    MAPeriod        = 14;
extern int    MAType          = 1;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsNotify    = false;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;


//---- buffers

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double slope[];

//---- variables

int    MAMode;
string strMAType;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(4);
   SetIndexBuffer(0,ExtMapBuffer3);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer1);
   SetIndexBuffer(3,slope);
   
switch (MAType)
   {
      case 1:  strMAType = " EMA ";  MAMode = MODE_EMA;  break;
      case 2:  strMAType = " SMMA "; MAMode = MODE_SMMA; break;
      case 3:  strMAType = " LWMA "; MAMode = MODE_LWMA; break;
      case 4:  strMAType = " LSMA ";                     break;
      default: strMAType = " SMA ";  MAMode = MODE_SMA;  break;
   }
   IndicatorShortName(strMAType+ " (" +MAPeriod + ") ");
   return(0);
  }


int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit = MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
   if (slope[limit]==-1) CleanPoint(limit,ExtMapBuffer2,ExtMapBuffer1);
   for(int i=limit; i>=0; i--)
   {
      if (MAType == 4)
      {
        ExtMapBuffer3[i] = 3.0*iMA(NULL,0,MAPeriod,0,MODE_LWMA,PRICE_CLOSE,i)-2.0*iMA(NULL,0,MAPeriod,0,MODE_SMA,PRICE_CLOSE,i);
      }
      else
      {
        ExtMapBuffer3[i] = iMA(NULL,0,MAPeriod,0,MAMode,PRICE_CLOSE,i);
      }
        ExtMapBuffer2[i] = EMPTY_VALUE;
        ExtMapBuffer1[i] = EMPTY_VALUE;
        slope[i] = slope[i+1];
        if(ExtMapBuffer3[i]>ExtMapBuffer3[i+1]) slope[i] = 1;
        if(ExtMapBuffer3[i]<ExtMapBuffer3[i+1]) slope[i] =-1;
        if (slope[i]==-1) PlotPoint(i,ExtMapBuffer2,ExtMapBuffer1,ExtMapBuffer3);
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
            int whichBar = 0;
      else      whichBar = 1;
      if (slope[whichBar] != slope[whichBar+1])
      if (slope[whichBar] == 1)
            doAlert("up");
      else  doAlert("down");       
   }   
return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}




//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS),strMAType+" nrp Color ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),strMAType+" nrp Color "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

